#Detecting the molding bench and spawning it
execute as @e[type=minecraft:glow_item_frame,tag=moldingbench,tag=!put] at @s run function wep:bench_related/summoner
#Detecting items put in the molding bench and determining it
execute as @e[tag=moldingbench,tag=put] at @s if entity @p[distance=..4] run function wep:craftingdetection/all
#Detecting if the molding bench is broken
execute as @e[tag=moldingbench,tag=put] at @s unless block ~ ~ ~ minecraft:dropper run function wep:bench_related/break



#Accelerating Trait Score clearance 
execute as @a if predicate wep:accelerating_activation_detection/accelerating_not_held run function wep:technical/trait_penalty/accelerating/acceleration_reset_all
execute as @a if predicate wep:accelerating_activation_detection/accelerating_not_sprinting run function wep:technical/trait_penalty/accelerating/acceleration_reset
#Accelerating Trait Score clearance (horse)
execute as @e[scores={we.horse.movement=1..}] run scoreboard players set @s we.horse.movement 0
execute as @e[scores={we.horse.movement=..0},predicate=wep:accelerating_activation_detection/accelerating_horse_idle] run function wep:technical/trait_penalty/accelerating/acceleration_reset_horse


#Flexible Trait detection system
execute as @a[tag=!we.flexible_debuff_added,nbt={SelectedItem:{components:{"minecraft:custom_data":{Flexible:1b}}}}] unless predicate wep:undefined/is_falling run function wep:technical/trait_penalty/flexible/flexible_i
execute as @a[tag=!we.flexible_debuff_added,nbt={SelectedItem:{components:{"minecraft:custom_data":{Flexible:2b}}}}] unless predicate wep:undefined/is_falling run function wep:technical/trait_penalty/flexible/flexible_ii



#Lethal Trait detection system
execute as @a[tag=!we.lethal_buff_added,nbt={SelectedItem:{components:{"minecraft:custom_data":{Lethal:1b}}}}] unless predicate wep:undefined/is_falling run function wep:technical/trait_penalty/lethal/lethal_i
execute as @a[tag=!we.lethal_buff_added,nbt={SelectedItem:{components:{"minecraft:custom_data":{Lethal:2b}}}}] unless predicate wep:undefined/is_falling run function wep:technical/trait_penalty/lethal/lethal_ii
execute as @a[tag=!we.lethal_buff_added,nbt={SelectedItem:{components:{"minecraft:custom_data":{Lethal:3b}}}}] unless predicate wep:undefined/is_falling run function wep:technical/trait_penalty/lethal/lethal_iii

#Lethal & Flexible effects removal system
execute as @a if predicate wep:undefined/is_falling run function wep:technical/trait_penalty/attribute_clearance
execute as @a unless predicate wep:undefined/wrong_tool run function wep:technical/trait_penalty/attribute_clearance



#Resets the score of the damage dealt to an entity unless if the player has landed a hit with a weapon carrying the denting trait
execute as @a at @s unless predicate wep:undefined/denting_trait_related run scoreboard players reset @s we.dealt
#Detects if an entity that has just taken damage is on a vehicle. And upon it, It will activate the condition checks to detect if it was hit in the right way to be dismounted
execute as @e[nbt={HurtTime:10s}] at @s if predicate wep:undefined/vehicle_status run function wep:technical/trait_penalty/hooking/condition_check

#Long bow detection
execute as @e at @s if predicate wep:undefined/longbow_detection run function wep:technical/longbow_mechanics/longbow_arrow_detection

#Mob weapons granting
execute as @e[type=minecraft:piglin_brute,tag=!we.checked] run function wep:technical/randomizers/brute
execute as @e[type=#wep:zombie,tag=!we.checked] run function wep:technical/randomizers/zombie
execute as @e[type=minecraft:piglin,tag=!we.checked] run function wep:technical/randomizers/piglin
execute as @e[type=minecraft:wither_skeleton,tag=!we.checked] run function wep:technical/randomizers/wither_skeleton

#Shield blocking detection
execute as @a[advancements={wep:technical/shield/shield_blocking_general=false}] run scoreboard players reset @s we.shield_block
execute as @a[advancements={wep:technical/shield/shield_blocking_general=true}] run advancement revoke @s only wep:technical/shield/shield_blocking_general


